/*Using filter in dynamic programming*/



/**********************************************************************************/
/*[  Name  ] Column Generation Solving parallel machine with times window problem */
/*[Designer]                                                                      */
/*[Complete data]  2004.03.16                                                     */
/* ********************************************************************************/


#include <fstream.h>
#include <iostream.h>
//#include <fstream.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <assert.h>
#include "ekk_c_api.h"
#include "malloc.h"
#include "time.h"
#include <set>
using namespace std;

#define NR_END        1
#define CASE_STEP    "N"
#define MAXSLOT      200                     //max node number in the path w 
#define __fabs(x)    (x < 0 ? (-x):(x))     //so XlC can inline fabs
#define M_MAX        25                     //the maximal number of vehicle   应该是机器？
//#define N_MAX        105                    //the maximal number of customer
#define N_MAX		 200
#define ADD_NUMB     5                      //the number of the columns to be added to the linear programming
#define EPS1         0.00001                 //using get the linear model
#define EPS2         0.00001                //using in dynamic programming to cauculate the
#define INFI         1e31    
#define Permit_Gap   0.00001                 //permit integer gap,used in teminate rules

int  Capacity;

/*---------------------------------------------------------------------------*/

int       J_num,M_num,C_num;          //工件数，机器数量，客户数量/列数？
double		  ProTime[N_MAX+1];        //
double		  Weight[N_MAX+1];         //权重？
double		CProTime[N_MAX+1];
double		CWeight[N_MAX+1];
int CNum[N_MAX+1]; 


double	  current_optimal;


int  f1,f2,f3;
char Pro_file[40]="process.txt";
char wei_file[60]="weight.txt";
char res_file[40]="single_result.txt";
char zhres_file[60]="zhresult.txt";
char resf_file[60]="res.txt";
char cnum_file[50]="cnum.txt";
char Mps_file[40]="simp.mps";
char *file_1,*file_2,*file_3,*file_4,*file_5,*file_6,*file_7,*file_8,*file_9;

FILE *inpro;
FILE *inwei;
FILE *inc;
FILE *outresult;
FILE *out_case;
FILE *Result;
FILE *column;
FILE *outzhresult;
FILE *Resultf;
	

struct n
{   
	int    solu_type;
	int    solu_numb;
	int    arc_matrix[N_MAX+1][N_MAX+1];
    double solution[N_MAX+2];
	int    soluindex[N_MAX+2];
	int    level;
	double lowerb;
	int    column_num;   /* column number in every branch node*/
	int    *Col;         /* corresponding column's index in pathlist*/
	int    r;            /* Branch Arc in this node*/
	int    s;
	int    tree;
	int    NodeB[N_MAX][N_MAX+2];
	struct n *next; 
};

struct n *nodelist;
struct n *result;


struct p
{
	int    No;                      
	int    lenth;     //job number in path 
	int    *path;
	//float  *start;
	double cost;
	struct p *before;
};
struct p *path_pool;   //use such pool in column management
struct p *pathlist;    //save every path which corresponding column has been add to Linear Model   
       

/*Using dynamical programming to caculate reduce cost*/
struct f
{
	double  ReduCost;
	int     job;
	float   time;
	struct  f *before;	
};


struct BF
{
	double FValue;
	int index_j;
	struct BF *before;
};


/***********this three variable is necessary for OSL****************/	
EKKVector  *opt_col;          //columns correspond to  optimal solution
EKKModel   *Linear_Mode;      //linear mode 
EKKContext *env;              //osl enviorment  


double    run_time,Max_runtime,Sum_runtime,Avg_runtime;
int       nodenum,Max_nodenum,Sum_nodenum; //the number of nodes explored
double    Avg_nodenum;                   
double    Gap,Max_Gap,Sum_Gap,Avg_Gap;
int       ColNumb,Max_ColNumb,Sum_ColNumb;
double    Avg_Colnumb;
int       NoSolve,SolveByHeu;
int       SolveAtRoot;
int       Case;

double    LBinBoot;     //LowerBound in root
double    HeuSol;       //initial solution generated by Heuristic 

int       NEW_COL_NUM;             //all column number be generated
int       *ColInParent;

int       con_m,var_n;             //constraint number and column number in linear model
double    *a;							             
double    dual_var[N_MAX+1];
/*the variables added by me*/
int sequence[200];
/*********************the character data of ***********************/
int current_route[20][200];
int current_machine_num;
int rootcolu,colunum,maxcolu;
int *InitialB,*B;


/*prepare operation and some other subprogram*/
void    init_infile(int example_index);
void    open_infile(int example_index);
void	init_outffile(int example_index);
void    close_infile();
void    out_file(void);
void    out_stat(void);
void    release_workspace(void);

double  Round( double x,int len);     // raeix points                           
void    print_path( struct p *nodepath);
void    init_para( );
void    OutResult( );
void   sort(struct n **list);
/*for every case ,preprocessing */
int     initial();
void    read_file();

/*generate the initial feasible solution*/
int     GenFirstRmp( ); 
//int     GenNewRmp(char tree,struct n *parentnode,int *Colu);
int     GenNewRmp(char tree,struct n *parentnode);
int     CheckLink( struct p *nodepath,int r, int s);        
//void    local_search(double temp_cost, int (*pt)[N_MAX+1],int t);

/*using dynamic programming algorithm solve sub problem*/
int     DynamicPro(double dual, double *dual_vars);
void    pop_path(struct p**nodepath);
void    push_path(struct p**nodepath);
void    add_path(int *path,double cost,int len);
void    add_path(struct p**nodepath);
struct  p * get_path(int No);
void    clear_pathlist( );
void    delete_path(int No);
 
void    linear_relax();
void    WriteMps(double *a,int m,int n);
void    eval(EKKModel *model);
void    ekk_init_linear( );
int     ekk_solve_linear( );
void    ekk_release( );
void    up_linear_mode( );
int     CacuDert(struct p *nodepath, double *dual_vars);
void    DelNobasCol(int ColNo);

/*branch & bound algorithm*/
void    backtracking(void);
void    GenerateNode(struct n *nownode);
void    pop(struct n **node);
void    push(struct n **node);
void    write_node(struct n *node,int NumbInCol,int old_col_num,int NEW_COL_NUM);
void    GetBranchArc(struct n *node);
void    Print_BranchNodeInf(int k,struct n *node);
/*the sub function added by me*/
int		Heuristic();
void open_outfile();
void init_outfile();
void close_outfile();
void quick(float a[],int left,int right,int sequence[]);
void chain_parameters(void);
//void    new_space();
//void	delete_space();
/****************************************************************************************/
/*   [flow chart]                                                                       */
/*   [step 1] Read file   proc_time[ ]  job_weight[ ]                                   */
/*   [step 2] reindex( ), Network_arcs()                                                */
/*   [step 3] Gen_RMP( )   heuristic scheduling generate restricted master problem      */
/*   [step 4] update linear mode--------------------|                                   */
/*   [step 5] solve linear releax                   |                                   */
/*   [step 6] princing   solve sub problem  --------|                                   */
/*   [step 7] B&B,go step3                                                              */
/****************************************************************************************/




/*****************************************************************************/
/* [      ]                                                                  */
/* [Name  ]    void main()                                                   */
/* [      ]                                                                  */
/*---------------------------------------------------------------------------*/
void main(void)
/*---------------------------------------------------------------------------*/
/* <    >                                                                    */
/*****************************************************************************/
{
	int rtn; 
	clock_t tick1,tick2;
	int J_scale,C_scale,M_scale;
	int CC[6][6],MM[6][6];
	int example_index;//differs in the exampel index,from 1-20
	
	CC[0][0]=2;	CC[0][1]=3;
	CC[1][0]=2; CC[1][1]=4;
	CC[2][0]=2; CC[2][1]=5;
	CC[3][0]=3; CC[3][1]=4;
	CC[4][0]=4; CC[4][1]=8;
	CC[5][0]=5; CC[5][1]=10;
	MM[0][0]=3;	MM[0][1]=5;
	MM[1][0]=3; MM[1][1]=5;
	MM[2][0]=4; MM[2][1]=5;
	MM[3][0]=3; MM[3][1]=5; MM[3][2]=6;
	MM[4][0]=6;	MM[4][1]=8; MM[4][2]=10;
	MM[5][0]=6; MM[5][1]=15; MM[5][2]=8;
	//M_num=5;
	//different problem scale
	for(M_scale=2;M_scale<=2;M_scale++)
	{
		for(J_scale=3;J_scale<=3;J_scale++)//from 1 to 10 corresponding to from 20 to 200
		{
			J_num=J_scale*20;//Job number
			for(C_scale=1;C_scale<=1;C_scale++)//from 1 to 10 corresponding to from 2 to 20
			{
				//C_num=C_scale*10;//chain number
				C_num=CC[J_scale][C_scale-1]*10;
				M_num=MM[J_scale][M_scale-1];
				init_outfile();
				open_outfile();
				for(example_index=1;example_index<=20;example_index++)//from 1 to 20
				{
					f3=example_index;
					InitialB=(int *)malloc(sizeof(int)*C_num*(C_num+2));
					B=(int *)malloc(sizeof(int)*C_num*(C_num+2));
					rootcolu=0;
					colunum=0;
					maxcolu=0;
					cout<<example_index<<endl;
					init_infile(example_index);
					open_infile(example_index);
					init_outffile(example_index);
					init_para( );
					path_pool=NULL;
					pathlist=NULL;
					var_n=0;
					rtn=initial();// read file, calloc memory space
					tick1=clock( );
					nodenum=0;
					NEW_COL_NUM=0;
					result=NULL;
					nodelist=NULL;
					backtracking( );
					tick2=clock( );
					run_time=(double)tick2/CLK_TCK - (double)tick1/CLK_TCK;
					out_file( );             //output every case solution */
					release_workspace( ); 
					clear_pathlist( );
					close_infile();
					free(InitialB);
					free(B);
				}
				out_stat( );
				close_outfile();
			}
		}
	}
}

void init_outfile()
{
	char C3[40],C4[40],C5[40];
	itoa(J_num,C3,10);
	itoa(C_num,C5,10);
	itoa(M_num,C4,10);

	//if(example_index==1)
	//{
		strcpy(zhres_file,"Output//");//输出文件
		strcat(zhres_file,C3);
		strcat(zhres_file,"-");
		strcat(zhres_file,C5);
		strcat(zhres_file,"-");
		strcat(zhres_file,C4);
		cout<<"zhres_file"<<endl;
		strcat(zhres_file,"//");
		strcat(zhres_file,"zhresult");
		strcat(zhres_file,".txt");
	//}

	strcpy(res_file,"Output//");//输出文件
	strcat(res_file,C3);
	strcat(res_file,"-");
	strcat(res_file,C5);
	strcat(res_file,"-");
	strcat(res_file,C4);
	strcat(res_file,"//");
	strcat(res_file,"result");
	strcat(res_file,".txt");
}
/*-----------------------------------------------------------------------------------------*/
/*                                                                                         */
/*--------------   Read relative data from file  && init some data    ---------------------*/
/*                                                                                         */
/*-----------------------------------------------------------------------------------------*/
/*Generate Input and Output FileName*/
void init_outffile(int example_index)
{	
	char C1[40],C2[40],C3[40],C4[40];
	itoa(J_num,C3,10);
	itoa(M_num,C2,10);
	itoa(C_num,C4,10);
	itoa(example_index,C1,10);

	strcpy(resf_file,"Output//");
	strcat(resf_file,C3);
	strcat(resf_file,"-");
	strcat(resf_file,C4);
	strcat(resf_file,"-");
	strcat(resf_file,C2);
	strcat(resf_file,"//");
	strcat(resf_file,"res");
	strcat(resf_file,"_");
	strcat(resf_file,C1);
	strcat(resf_file,".txt");

	if((Resultf=fopen(resf_file,"w"))==NULL)
	{
		printf("Cannot open file_in. %s\n",resf_file);
		exit(0);
	}
}


/*Generate Input and Output FileName*/
void init_infile(int example_index)
{	
	char C1[40],C2[40],C3[40];
	itoa(C_num,C3,10);
	itoa(J_num,C2,10);
	itoa(example_index,C1,10);

	strcpy(Pro_file,"WC\\");
	strcat(Pro_file,C2);
	strcat(Pro_file,"-");
	strcat(Pro_file,C3);
	strcat(Pro_file,"\\ptime_file");
	strcat(Pro_file,C3);
	strcat(Pro_file,"_");
	strcat(Pro_file,C2);
	strcat(Pro_file,"_");
	strcat(Pro_file,C1);
	strcat(Pro_file,".txt");

	strcpy(wei_file,"WC\\");
	strcat(wei_file,C2);
	strcat(wei_file,"-");
	strcat(wei_file,C3);
	strcat(wei_file,"\\weight_file");
	strcat(wei_file,C3);
	strcat(wei_file,"_");
	strcat(wei_file,C2);
	strcat(wei_file,"_");
	strcat(wei_file,C1);
	strcat(wei_file,".txt");

	strcpy(cnum_file,"WC\\");
	strcat(cnum_file,C2);
	strcat(cnum_file,"-");
	strcat(cnum_file,C3);
	strcat(cnum_file,"\\CNum_file");
	strcat(cnum_file,C3);
	strcat(cnum_file,"_");
	strcat(cnum_file,C2);
	strcat(cnum_file,"_");
	strcat(cnum_file,C1);
	strcat(cnum_file,".txt");

}
void open_outfile()
{								
	//if(example_index==1)
	//{
		if((outzhresult=fopen(zhres_file,"w"))==NULL)
		{
			printf("Cannot open file_in. %s\n",zhres_file);
			exit(0);
		}
	//}
	if((outresult=fopen(res_file,"w"))==NULL)
	{
		printf("Cannot open file_in. %s\n",res_file);
		exit(0);
	}
}
/*Open The generated File*/
void open_infile(int example_index)
{								
	if((inpro=fopen(Pro_file,"r"))==NULL)
	{
		printf("Cannot open this file. %s\n",Pro_file);
		exit(0);
	}
	if((inwei=fopen(wei_file,"r"))==NULL)
	{
		printf("Cannot open this file. %s\n",wei_file);
		exit(0);
	}
	if((inc=fopen(cnum_file,"r"))==NULL)
	{
		printf("Cannot open this file. %s\n",cnum_file);
		exit(0);
	}
}


void out_file(void)
{
   	Case++;
	Max_runtime=__max(Max_runtime,run_time);
	Sum_runtime+=run_time;
	Max_nodenum=__max(Max_nodenum,nodenum);
	Sum_nodenum+=nodenum;
	if(nodenum==1)
		SolveAtRoot++;
	//Gap=__fabs(Round((result->lowerb -  LBinBoot)/LBinBoot ,4));
	Gap=__fabs(Round((current_optimal-LBinBoot)/LBinBoot,4));
    Max_Gap=__max(Max_Gap,Gap);
	Sum_Gap+=Gap;
	ColNumb=NEW_COL_NUM;
	Max_ColNumb=__max(Max_ColNumb,ColNumb);
	Sum_ColNumb+=ColNumb;
	
	
	/*if (f3==25)
	{
		Avg_runtime= Round(Sum_runtime/Case,4);
        Avg_nodenum= Round(Sum_nodenum/Case,1); 
        Avg_Gap    = Round(Sum_Gap/Case,4);
		Avg_Colnumb= Round(Sum_ColNumb/Case,0);
	}*/
	if(f3==1)
	{
		fprintf(outresult,"%s\t%s\t","Job_num","machine_num");
		fprintf(outresult,"%s\t\t%s\t\t","Solution","LowerB");
		fprintf(outresult,"%s\t","HeuSol");
		fprintf(outresult,"%s\t\t%s\t%s\t","GapL","GapH","time(s)");
		fprintf(outresult,"%s\t%s\t\n","nodenum","colunum");
		fprintf(outresult,"%s\t%s\t\n","rootcolu","mxcolu");
	}	

	

    fprintf(outresult,"\n%d\td\t\t%d\t",J_num,C_num,M_num);
	fprintf(outresult,"%-8.2f\t\t%-8.2f\t\t",current_optimal,LBinBoot);
	fprintf(outresult,"%-8.0f\t",HeuSol);
	fprintf(outresult,"%-8.4f\t\t%-8.4f\t%-8.2f\t",Gap,(HeuSol-current_optimal)/current_optimal,run_time);
	fprintf(outresult,"%-8d\t",nodenum);
	fprintf(outresult,"%-8d\t%-8d\t%-8d\n",colunum,rootcolu,maxcolu);

	fprintf(Resultf,"\n%d\td\t\t%d\t",J_num,C_num,M_num);
	fprintf(Resultf,"%-8.2f\t\t%-8.2f\t\t",current_optimal,LBinBoot);
	fprintf(Resultf,"%-8.0f\t",HeuSol);
	fprintf(Resultf,"%-8.4f\t\t%-8.4f\t%-8.2f\t",Gap,(HeuSol-current_optimal)/current_optimal,run_time);
	fprintf(Resultf,"%-8d\t",nodenum);
	fprintf(Resultf,"%-8d\t%-8d\t%-8d\n",colunum,rootcolu,maxcolu);
	
} 

void out_stat(void)
{
	//fprintf(out,"\n-----------------------------------------\n");
	//printf("\n-----------------------------------------\n");
	//fprintf(out,"max=%6.2f\tmin=%6.2f\tmean=%6.2f\ttime=%6.2f\tNUM=%4.2f\n\n",M1,M2,M3/10.0,M4/10.0,M5/10.0);
	//printf("max=%6.2f\tmin=%6.2f\tmean=%6.2f\ttime=%6.2f\tNUM=%4.2f\n\n",M1,M2,M3/10.0,M4/10.0,M5/10.0);
	if(Case>0) 
	{
		Avg_runtime= Round(Sum_runtime/Case,4);
        Avg_nodenum= Round(Sum_nodenum/Case,1); 
        Avg_Gap    = Round(Sum_Gap/Case,4);
		Avg_Colnumb= Round(Sum_ColNumb/Case,0);
	}
	fprintf(outzhresult,"\n\n-------------------------------------------------------");
	fprintf(outzhresult,"-----------------------------------------------------------");
	fprintf(outzhresult,"-----------------------------------------------------------");
	fprintf(outzhresult,"-------------------------------------------\n");
    fprintf(outzhresult,"%s\t%s\t%s\t%s\t%s\t","J_num","C_num","M_num","Avg_Gap","Max_Gap");
    fprintf(outzhresult,"%s\t","SolAtRoot");
	fprintf(outzhresult,"%-s\t%s\t","Avg_nodenum","Max_nodenum");
	fprintf(outzhresult,"%s\t%s\t","Avg_runtime","Max_runtime");
	fprintf(outzhresult,"%s\t%s\t","Avg_Col","Max_Col");
	fprintf(outzhresult,"%s\t%s\t\n","SolvByHeu","Unsolv");
    fprintf(outzhresult,"-----------------------------------------------------------");
	fprintf(outzhresult,"-----------------------------------------------------------");
	fprintf(outzhresult,"-----------------------------------------------------------");
	fprintf(outzhresult,"---------------------------------------\n");
    fprintf(outzhresult,"%d\t\t%d\t\t%d\t%-8.4f\t%-8.4f\t",J_num,C_num,M_num,Avg_Gap,Max_Gap);
    fprintf(outzhresult,"%-8d/25\t\t",SolveAtRoot);
	fprintf(outzhresult,"%-8.1f\t\t%8d\t\t",Avg_nodenum,Max_nodenum);
	fprintf(outzhresult,"%-8.2f\t\t%-8.2f\t\t",Avg_runtime,Max_runtime);
    fprintf(outzhresult,"%-8.1f\t%-8d\t",Avg_Colnumb,Max_ColNumb);
	fprintf(outzhresult,"%8d\t%8d\t\n",SolveByHeu,NoSolve);
}


void close_infile()
{
	fclose(inpro);
	fclose(inwei);
	fclose(inc);
	fclose(Resultf);
	
}
void close_outfile()
{
	fclose(outresult);
	fclose(outzhresult);
}

void release_workspace(void)
{
	//struct point_pair *temp_point_pair;
	struct n *P;
	delete [] result;
	
	while(nodelist!=NULL)
	{
		P=nodelist->next;
		delete [] nodelist->Col;
		delete [] nodelist;
		nodelist=P;
	}
	/*temp_point_pair=point_pair;
	while(point_pair!=NULL)
	{
		temp_point_pair=point_pair;
		point_pair=point_pair->before;
		free(temp_point_pair);
	}*/
	ekk_release( );
}

void init_para( )
{
	run_time=0;
	Max_runtime=0;
	Sum_runtime=0;
	Avg_runtime=0;
    
	nodenum=0;
	Max_nodenum=0;
	Sum_nodenum=0;
	Avg_nodenum=0;          
    
	Gap,Max_Gap=0;
	Sum_Gap=0;
	Avg_Gap=0;
    
	ColNumb=0;
	Max_ColNumb=0;
	Sum_ColNumb=0;
	Avg_Colnumb=0;
    
	HeuSol=0;
	NoSolve=0;
    SolveAtRoot=0;
	SolveByHeu=0;
	Case=0;
}


void quick(double a[],int left,int right,int sequence[])
{
	int i,j,p,pa;
	double ba;
	if(left<right) 
	{
		i=left;
		j=right;
		ba=a[sequence[left]];
		pa=sequence[left];
		while(i!=j)
		{
			while(a[sequence[j]]>ba && j>i)
				j--;
			if(i<j)
			{				
				/*pa=a[sequence[i]];
				a[sequence[i]]=a[sequence[j]];
				a[sequence[j]]=pa;*/
				p=sequence[i];
				sequence[i]=sequence[j];
				sequence[j]=p;
				i++;
			}
			//for(p=0;p<20;p++)
			//	cout<<a[sequence[p]]<<'	'<<sequence[p]<<endl;
			while(a[sequence[i]]<ba && j>i)
				i++;
			if(i<j)
			{
				/*pa=a[sequence[j]];
				a[sequence[j]]=a[sequence[i]];
				a[sequence[i]]=pa;*/
				p=sequence[j];
				sequence[j]=sequence[i];
				sequence[i]=p;
				j--;
			}
			//for(p=0;p<20;p++)
			//	cout<<a[sequence[p]]<<'	'<<sequence[p]<<endl;
		}
		//a[i]=ba;
		sequence[i]=pa;
		//for(p=0;p<20;p++)
		//	cout<<a[sequence[p]]<<'	'<<sequence[p]<<endl;
		//a[i]=ba;
		i++;
		j--;
		quick(a,left,j,sequence);
		quick(a,i,right,sequence);
	}
	else
		return;
}

/*------------------------------------------------------------------------------------*/
/*                                                                                    */
/*----------------------------  End of relative data from file  ----------------------*/
/*                                                                                    */
/*------------------------------------------------------------------------------------*/

/************************************************************************************/
/*[  Name  ]initial                                                                 */
/*[Function]For every case,do some ready work                                       */
/*[ Return ]     0 success generate initial feasible solution                       */
/*               1 The initial feasiable solution is optimal                        */
/*              -1 failed to generate initial feasiable solution                    */
/*----------------------------------------------------------------------------------*/
int initial()
{
    int rtn;//just a sign
	
	int i,j;
	double pw[200];
	read_file();
	chain_parameters();
	for(i=0;i<C_num;i++)
	{
		pw[i]=(*(CProTime+i))/(*(CWeight+i));
		//cout<<pw[i]<<'	';
	}
	//cout<<endl;
	for(i=0;i<C_num;i++)
		sequence[i]=i;
	quick(pw,0,C_num-1,sequence);
	rtn=Heuristic();//this heuristic need to be change
	if(rtn==0)
		GenFirstRmp( );
	//这个应该放在initial里面
	for(i=0;i<C_num;i++)
	{
		*(InitialB+i*(C_num+1)+0)=0;
		*(B+i*(C_num+1)+0)=0;
		*(InitialB+i*(C_num+1)+*(InitialB+i*(C_num+1)+0)+1)=0;//都加个1，为了配合后面的状态变量
		*(B+i*(C_num+1)+*(B+i*(C_num+1)+0)+1)=0;
		*(InitialB+i*(C_num+1)+0)=*(InitialB+i*(C_num+1)+0)+1;
		*(B+i*(C_num+1)+0)=*(B+i*(C_num+1)+0)+1;
		for(j=0;j<i;j++)
		{
			*(InitialB+i*(C_num+1)+*(InitialB+i*(C_num+1)+0)+1)=j+1;//都加个1，为了配合后面的状态变量
			*(B+i*(C_num+1)+*(B+i*(C_num+1)+0)+1)=j+1;
			*(InitialB+i*(C_num+1)+0)=*(InitialB+i*(C_num+1)+0)+1;
			*(B+i*(C_num+1)+0)=*(B+i*(C_num+1)+0)+1;
		}
	}
	return rtn;
}

void chain_parameters(void)
{
	int i,j,k;
	//The computing of of CP
	for(j=0;j<C_num;j++)
		CProTime[j]=0;
	i=0;
	for(j=0;j<C_num;j++)
	{
		CWeight[j]=0;
		CProTime[j]=0;
		for(k=i;k<i+CNum[j];k++)
		{
			CWeight[j]=CWeight[j]+Weight[k];
			CProTime[j]=CProTime[j]+ProTime[k];
		}
		i=i+CNum[j];
	}
}



/************************************************************************************/
/*[  Name  ] read_file                                                              */
/*[Function] read data from file                                                    */
/*----------------------------------------------------------------------------------*/
void read_file()
{   
	int i;
	for(i=0;i<J_num;i++)
	{
		fscanf(inpro,"%lf",ProTime+i);
		fscanf(inwei,"%lf",Weight+i);
	}
	for(i=0;i<C_num;i++)
		fscanf(inc,"%d",CNum+i);
}


/*------------------------------------------------------------------------------*/
/*                                                                              */
/*--------------------Solve Linear relaxtion of the master problem -------------*/
/*                                                                              */
/*------------------------------------------------------------------------------*/


/******************************************************************************/
/* [  	  ]                                 				                  */
/* [  Name  ]    void linear_relax()                                          */
/* [Function]    					                                          */
/*		    					                                              */
/*----------------------------------------------------------------------------*/
void linear_relax()
/*----------------------------------------------------------------------------*/
{
	/*int i;
	upsim_num=0;*/ 
	int       rtn;
	int       rt;
	int       i=0;
	struct p  *TemPath;
	path_pool=NULL;
    rt=ekk_solve_linear( );
    if(rt==-1)//can get into this case in most cases
	{ 
		printf("error occour during solve linear program\n");
	    getchar();
		exit(0);
	}
	while(1)
	{	
		/*If we generate 1500 columns ,we terminate the linear relax*/
        if(var_n>5000)
		{		
			while(path_pool)
			{
				pop_path(&TemPath);
                free(TemPath->path);
				free(TemPath);
			}
			break;
		}
		if(path_pool==NULL)
		{
			//before doing this，需要构造一个函数找出哪些点必须在一列中出现，哪些点之间不能够同时出现在一列之中
			rtn=DynamicPro(*dual_var,dual_var); 
			//the return value of the pricing() denotes whether the current solution of the 
		    //linear relaxation is optimal
			if(rtn==0)     //the current solution is optimal
			{
				break;   
			}
		    //terminate the pricing algorithm
			if(rt==-999)
			{
				break;
			}
		}
		up_linear_mode( );
		/*here use the ekk api solve the linear program*/
		rt=ekk_solve_linear( );
		if(rt==-1)
		{
			printf("error occour during solve linear program\n");
			getchar();
		    exit(0);
		}     
	}
}


void ekk_init_linear( )
{
    //// write *.mps file  	
	WriteMps(a,con_m,var_n);
    // Initialize OSL environment   
    env = ekk_initializeContext();
    // Create an OSL model "test"      
    Linear_Mode = ekk_newModel(env,NULL);
	// set the osl print mesaage off //add
    ekk_messagesPrintOff(Linear_Mode,1,377777777);//add
    // Read model data from MPS file 
    //int rtcod=ekk_importModel(Linear_Mode,"simp.mps");
	int rtcod=ekk_importModel(Linear_Mode,Mps_file);
}


int ekk_solve_linear( )
{
    int i;
	int m;
	int n;
	int l;
	int rtcod;
	double opt,*solution;
	struct   p *NowPath;
	double temp[200],j;
	
	//ekk_scale(test);
	// set the model minimize
    ekk_setMinimize( Linear_Mode );
	// Solve using simplex method     
    //rtcod = ekk_primalSimplex(test,2);
	rtcod=ekk_primalSimplex(Linear_Mode,2);
	
	ekk_createBInverse(Linear_Mode); 
    
	//get the shadow price
	const double *dual=ekk_getRowduals(Linear_Mode);  
	
    //get the opt solution
	const double *soln=ekk_colsol(Linear_Mode);
    
    m=ekk_getInumrows(Linear_Mode);
    n=ekk_getInumcols(Linear_Mode);
	
	/*for(i=0;i<m;i++)
		cout<<*(dual+i)<<'	';
	cout<<endl;*/
    /*for(i=0;i<m;i++)
		printf("%12lf\t",dual[i]);
	printf("\n");*/
	/*for(i=0;i<n;i++)
		printf("%12lf\t",soln[i]);
	printf("\n");*/
	opt=ekk_getRobjvalue(Linear_Mode);
	solution=(double *)malloc(sizeof(double)*n);
	for(i=0;i<n;i++)
		*(solution+i)=Round(soln[i],6);
	/*for(i=0;i<J_num;i++)
		temp[i]=0;
	j=0;
	for(l=0;l<n;l++)
	{
		if(*(solution+l)>0)
		{
			NowPath=get_path(l+1);
			if(NowPath==NULL)
			{
				printf("Error When Getcol in GetBranchArc \n");
				getchar( );
				exit(0);
			}
			for(i=1;i<=NowPath->lenth;i++)
			{
				cout<<NowPath->path[i]<<'	';
				temp[NowPath->path[i]-1]=temp[NowPath->path[i]-1]+*(solution+l);
			}
			j=j+*(solution+l);
			cout<<NowPath->cost<<endl;
		}
	}*/
	/*for(i=0;i<n;i++)
		cout<<*(solution+i)<<'	';
	cout<<endl;*/
	/*printf("the lower bound of this node is:%12lf\n",opt);*/
	for(i=0;i<m;i++)
		dual_var[i]=Round(dual[i],6);
    /*for(i=0;i<m;i++)
	{
		printf("dual[%d]=%lf\t",i,dual[i]);
		if((i+1)%3==0)
			printf("\n");
	}
	const double  *obj= ekk_getObjective( Linear_Mode ); 
	for(i=0;i<n;i++)
		if (soln[i]>=0.000001)
          printf("opt[%d]=%lf  obj[%d]=%lf\n",i,soln[i],i,obj[i]);*/
	free(solution);

	return 0;
}


void ekk_release( )
{
	int rtcod;
	// Delete the model     
	rtcod = ekk_deleteModel(Linear_Mode);
    // OSL Destructor                 
    ekk_endContext(env);
}

/**********************************************************************/
/*[  Name  ] WriteMps                                                 */
/*[Function] write Mps fil                                            */
/*                                                                    */
/*--------------------------------------------------------------------*/

void WriteMps(double *a,int m,int n)
{
	int  i,j;
	double  up,low;
	//char Mps_file[40]="simp.mps";
    FILE  *simp;
	char C10[10];
	itoa(nodenum,C10,10);
	
    //ifstream simp("simp.mps",ios::out);
	strcpy(Mps_file,"simp");
	strcat(Mps_file,C10);
	strcat(Mps_file,".mps");
	simp=fopen(Mps_file,"w");
	//simp=fopen("simp.mps","w");

	fprintf(simp,"NAME          EXAMPLE\n");
	fprintf(simp,"ROWS\n");
	for(i=0;i<m;i++)
	{
		if(i==0)
			fprintf(simp," N  OBJ\n");
		else if(i==1)
			fprintf(simp," L  ROW%d\n",i);
		else 
			fprintf(simp," E  ROW%d\n",i);
	}
	fprintf(simp,"COLUMNS\n");
	for(j=1;j<=n;j++)
	{
		if(a[j]!=0)
			fprintf(simp,"    COL%-5d   OBJ        %12lf\n",j,a[j]);
		for(i=1;i<m;i++)
		{
			if(a[i*(n+1)+j]>=0.0000001)
				fprintf(simp,"    COL%-5d   ROW%-5d   %12lf\n",j,i,a[i*(n+1)+j]);
		}
	}
	fprintf(simp,"RHS \n");
	for(i=1;i<m;i++)
	{
		fprintf(simp,"    RHS1       ROW%-5d   %12lf\n",i,a[i*(n+1)]);
	}
	fprintf(simp,"RANGES \n");
	
	fprintf(simp,"BOUNDS \n");
	up=1.0;
	low=0.0;
	for(j=1;j<=n;j++)
	{
		fprintf(simp," LO BND1      COL%-5d   %12lf\n",j,low);
        fprintf(simp," UP BND1      COL%-5d   %12lf\n",j,up);
	}
	fprintf(simp,"ENDATA");
    fclose(simp);
}


/**********************************************************************/
/*[  Name  ] up_linear_mode                                           */
/*[Function] add the column generate by pricing to linear model       */
/*                                                                    */
/*--------------------------------------------------------------------*/

void up_linear_mode( )
{
    int     rtcod;
	int     i,j,k;
    double  objectiveCoefficient;
    int     startOfEachColumn;
    int     *indexRow;
    double  *element;
	int     *TempCol;
    struct  p *nodepath,*criterion;
    int     reduce_falg;
	int     *pp;
    int     iter;
	int		signa;
	

	//TempCol=new int[customer_num+3];
	TempCol=new int[C_num+3];
	indexRow=(int *)malloc(con_m*sizeof(int));
    element=(double *)malloc(con_m*sizeof(double));
	iter=0;
	//printf("var_n=%d\n",var_n);
	while(1)
	{
		nodepath=NULL;
		pop_path(&nodepath);
		if(nodepath)
		{
			reduce_falg=CacuDert(nodepath,dual_var);
			/*if(reduce_falg==1)
			{
				criterion=pathlist;
				while(1)
				{
					if(criterion==NULL)
						break;
					if(criterion->lenth==nodepath->lenth)
					{
						k=0;
						for(i=1;i<=nodepath->lenth;i++)
						{
							signa=0;
							for(j=1;j<=criterion->lenth;j++)
							{
								if(nodepath->path[i]==criterion->path[j])
								{
									k++;
									signa=1;
									break;
								}
							}
							//if(k!=i)
							if(signa==0)
								break;
						}
						//if(k==nodepath->lenth)
						if(signa==1)
						{
							reduce_falg=0;
							break;
						}
					}
					criterion=criterion->before;
				}
			}*/
			if(reduce_falg==1) 
			{  // test the col with reduce cost 
				TempCol[0]=1;
				for(i=1;i<=C_num;i++)
					TempCol[i]=0;
				for(i=1;i<=nodepath->lenth;i++)
				{
					TempCol[nodepath->path[i]]+=1;
				}					
				objectiveCoefficient=nodepath->cost;
				k=0;
				for(j=0;j<con_m-1;j++)
				{
					if(TempCol[j]!=0)
					{
						indexRow[k]=j;
						element[k]=(double)TempCol[j];
						k++;
					}
				}
				startOfEachColumn=0;   //In this Model this first element in the column must be 1 ,so...
				rtcod=ekk_addOneColumn(Linear_Mode,objectiveCoefficient,startOfEachColumn,1,k,indexRow,element);
				if(rtcod!=0)
				{
					printf("error occur during  Add column to linear mode\n");
					exit(0);
				}
				var_n=var_n+1;
				NEW_COL_NUM+=1;
				add_path(&nodepath);
				iter++;
			}
			else
			{
				pp=nodepath->path;
				free(pp);
				free(nodepath);
			}
		}
		else
			break;
		if(iter>=ADD_NUMB)
			break;
	} 
  
 // ekk_exportModel( Linear_Mode , "out.mps" , 1, 1); 
	free(indexRow );
	free(element );
	delete [] TempCol;
	//fclose(D);
	
}


/**********************************************************************/
/*[  Name  ]                                                          */
/*[Function]Add column to model                                       */
/*                                                                    */
/*--------------------------------------------------------------------*/
void AddNewCol(struct p *nodepath)
{
	int     rtcod;
	int     i,j,k;
    double  objectiveCoefficient;
    int     startOfEachColumn;
    int     *indexRow;
    double  *element;
	int     *TempCol;
    
	TempCol = new int[C_num+3];
	indexRow= (int *)malloc(con_m*sizeof(int));
    element = (double *)malloc(con_m*sizeof(double));

    TempCol[0]=1;
	
	//for(i=1;i<=customer_num;i++)
	for(i=1;i<=C_num;i++)
	    TempCol[i]=0;
    for(i=1;i<=nodepath->lenth;i++)
		TempCol[nodepath->path[i]]+=1;
	objectiveCoefficient=nodepath->cost;
    k=0;
    for(j=0;j<con_m;j++)
	{
		if(TempCol[j]!=0)
		{
			indexRow[k]=j;
			element[k]=(double)TempCol[j];
			k++;
		}
	}
	startOfEachColumn=0;   
    rtcod=ekk_addOneColumn(Linear_Mode,objectiveCoefficient,startOfEachColumn,1,k,indexRow,element);
	if(rtcod!=0)
	{
		printf("error occur during  Add column to linear mode\n");
		exit(0);
	}    
	free(indexRow);
	free(element);
	delete [] TempCol;
}
/********************************************************************************/
/*[  Name  ]GenFirstRmp                                                         */
/*[Function]Generate restricted master problem in the first branch tree node    */
/*                                                                              */
/*------------------------------------------------------------------------------*/

int  GenFirstRmp( )
{
   	int        i,j,k;
    int        column_set[N_MAX+1][M_MAX+1];
	double     temp_cost;
    int        RN;
    double     *RMP_cost;
    struct n   *feasible;
    struct p   *temp_path;
	NEW_COL_NUM=current_machine_num;
	con_m=C_num+2;
	var_n=current_machine_num;
	RN=var_n+1;
	a=(double *)malloc((con_m+1)*(var_n+1)*sizeof(double));
	RMP_cost =new double[current_machine_num+1];
	temp_path=path_pool;
	for(i=1;i<=current_machine_num;i++)
	{
        temp_path=get_path(i);
		if(temp_path==NULL)
		{
			printf("Error Occur,first vehicle_num path don't exist\n");
			exit(0);
		}
		RMP_cost[i]=temp_path->cost;
		for(j=1;j<=C_num;j++)
			column_set[j][i]=0;
		for(j=1;j<=temp_path->lenth;j++)
		{
			for(k=0;k<C_num;k++)
			{
				if(temp_path->path[j]==k+1)
					column_set[k+1][i]++;
			}
		}
	}
	temp_cost=0.0;
	for(j=1;j<=current_machine_num;j++)
		temp_cost+=RMP_cost[j];
	feasible=new struct n;
	feasible->lowerb=temp_cost;
	feasible->level=0;
	HeuSol=temp_cost;
	for(i=1;i<C_num;i++)
		for(j=1;j<=current_machine_num;j++)
			feasible->column_num=NEW_COL_NUM;
	result=feasible;
	for(j=1;j<=var_n;j++)           /*c------------------*/
	{
		a[j]=RMP_cost[j];
	}
	for(i=1;i<con_m;i++)           /*b------------------*/
	{
		if(i==1)
			a[i*RN+0]=(double)(M_num);
		else
			a[i*RN+0]=1;
	}
	for(j=1;j<=var_n;j++)/*a1,j------------------*/
	{
		a[1*RN+j]=1;
	}
	for(i=2;i<con_m;i++)
		for(j= 1;j<=var_n;j++)
		{
			a[i*RN+j]=(double)column_set[i-1][j];
		}
	//WriteMps(a,con_m,var_n);
	//v_gap=a[1*RN+0]-floor(double((Capacity-coil_select_gap)/capacity))-1;
	ekk_init_linear( );
	free(a);
	delete [] RMP_cost;
	return 0;
}

/****************************************************************************/
/*[  Name  ] GenNewRmp                                                      */
/*[Function] Generate restrict master problem in every branch node          */
/*           except the boot bode                                           */
/****************************************************************************/

int GenNewRmp(int tree,struct n *parentnode)
{
	int     r,s;
	int     i,j;
	int     l;
    int     columnNumb;
	int     *Col;
	struct  p *nodepath;
    int     RN;
    int     *TempCol;
    int     rtcod;
	int     rtn;
	

	r=parentnode->r;
	s=parentnode->s;

	TempCol=new int[C_num+3];
	rtcod = ekk_deleteModel(Linear_Mode);
    ekk_endContext(env);
    
	columnNumb=parentnode->column_num;
	Col=parentnode->Col;

	var_n=0;
	i=0;
	if(parentnode->r>0 && parentnode->s>0)
	{
		if(tree==1)//左分支，点r和点s应该在一个列中
		{
 			for(l=1;l<=columnNumb;l++)
			{
				nodepath=get_path(Col[l]);
				rtn=CheckLink(nodepath,r,s);
				if(rtn==1 || rtn==2)
				{  /*Unlink*/
					var_n++;
					ColInParent[var_n]=Col[l];
				}
				if(rtn==1)
					i++;
			}
		}
		else if(tree==2)
		{
			for(l=1;l<=columnNumb;l++)
			{
				nodepath=get_path(Col[l]);
				rtn=CheckLink(nodepath,r,s);
				//if( CheckSuc(nodepath,r,s)==0 && CheckPrc(nodepath,r,s)==0)
				if(rtn==0 || rtn==2)
				{
					var_n++;
					ColInParent[var_n]=Col[l];
				}
				if(rtn==0)
					i++;
			}	
		}
		else
		{
			printf("Parameter error,tree must be 1 or 2,So tree=%d is err",tree);
			exit(0);
		}
	}
	
	RN=var_n+1;
   	a=(double *)malloc((con_m+1)*(var_n+1)*sizeof(double));
    for(j=1;j<=var_n;j++)//这里需要加新的约束就是r和s必须在某一列中或者一定不能在一列中
	{
		nodepath=get_path(ColInParent[j]);
		TempCol[0]=1;
	    for(i=1;i<=C_num;i++)
	        TempCol[i]=0;
        for(i=1;i<=nodepath->lenth;i++)
		{
			TempCol[nodepath->path[i]]+=1;
		}
		a[j]=nodepath->cost;
		a[1*RN+j]=1;
	    for(i=2;i<=con_m;i++)
		{
			a[i*RN+j]=(double)TempCol[i-1];
		}
	}
    for(i=1;i<=con_m;i++)
	{
		if(i==1)
			a[i*RN +0]=(double)M_num;
		else
			a[i*RN +0]=1;
	}
	//WriteMps(a,con_m,var_n);
    ekk_init_linear( );
    free(a);
    delete [] TempCol;
    return 0;
}
/**********************************************************************/
/*[  Nmae  ]
/*[Function]Checked two job's linked in a path                        */
/*                                                                    */
/*--------------------------------------------------------------------*/
int CheckLink(struct p *nodepath,int r,int s)
{
	int rtn=0;
    int i,a,b;//检查当前列是否可以放入新的节点里
	a=0;
	b=0;
	for(i=1;i<nodepath->lenth;i++)
	{
		if((nodepath->path[i]==r)&&(nodepath->path[i+1]==s))
		{
			rtn=1;
			break;
		}
	}
	if(rtn==0)
	{
		for(i=1;i<=nodepath->lenth;i++)
		{
			if(nodepath->path[i]==r)
				a=1;
			if(nodepath->path[i]==s)
				b=1;
			if(a==1 && b==1)
				break;
		}
		if(a==0 && b==0)
			rtn=2;
	}
	return rtn;
}

/**********************************************************************/
/*[  Nmae  ]
/*[Function]Checked two job's linked in a path                        */
/*                                                                    */
/*--------------------------------------------------------------------*/
int CheckSuc(struct p *nodepath,int r,int s)
{
	int rtn=0;
    int i;
	for(i=1;i<nodepath->lenth;i++)
	{
		if((nodepath->path[i]==r)&&(nodepath->path[i+1]!=s))
		{
			rtn=1;
			break; 
		}
	}
	return rtn;
}
/**********************************************************************/
/*[  Nmae  ]
/*[Function]Checked two job's linked in a path                        */
/*                                                                    */
/*--------------------------------------------------------------------*/
int CheckPrc(struct p *nodepath,int r, int s)
{
	int rtn=0;
    int i;
	for(i=2;i<=nodepath->lenth;i++)
	{
		if(nodepath->path[i-1]!=r && nodepath->path[i]==s)
		{
			rtn=1;
			break;
		}
	}
	return rtn;
}














/**************************************************************************/
/*[  Name  ]                                                              */
/*[Function]  Using Heuristic Algorithm to generate feasible solution     */
/*[return]     0 feasible                                                 */
/*            -1 infesible                                                */
/*             //1 optimization                                             */
/*------------------------------------------------------------------------*/

int Heuristic()
{
	int rtn;
	int  *path ;
	int i,j,k,h;
	double C[200];
	double objective;
	double temp;
	int *m;
	double *ReadyTime;
	int *ReadySequence;
	int InterTime;
	int *BestM;
	double *BestObjective;
	int TempValue;
	double H,K;
	int b;
	double c,l;
	//预处理
	m=(int *)malloc(sizeof(int)*(C_num+1)*M_num);
	BestM=(int *)malloc(sizeof(int)*(C_num+1)*M_num*11);//找10个最好的解
	BestObjective=(double *)malloc(sizeof(double)*11);
	ReadyTime=(double *)malloc(sizeof(double)*M_num);
	ReadySequence=(int *)malloc(sizeof(int)*M_num);
	for(i=0;i<10;i++)
	{
		*(BestObjective+i)=10000000;
		for(j=0;j<M_num;j++)
			*(BestM+i*(C_num+1)*M_num+j*(C_num+1)+0)=0;
	}
	srand((unsigned)time(NULL));
	for(InterTime=0;InterTime<5000;InterTime++)
	{
		for(i=0;i<M_num;i++)
		{
			*(m+i*(C_num+1)+0)=1;
			*(m+i*(C_num+1)+*(m+i*(C_num+1)+0))=sequence[i];
			*(ReadyTime+i)=CProTime[sequence[i]];
			*(C+sequence[i])=CProTime[sequence[i]];
		}
		if(M_num>2)
		{
			for(i=M_num;i<C_num-1;i++)
			{
				for(j=0;j<M_num;j++)
					*(ReadySequence+j)=j;
				quick(ReadyTime,0,M_num-1,ReadySequence);
				temp=float(rand())/32857;
				if(temp<0.8)
				{
					*(m+(*(ReadySequence+0))*(C_num+1)+0)=*(m+(*(ReadySequence+0))*(C_num+1)+0)+1;
					*(m+(*(ReadySequence+0))*(C_num+1)+*(m+(*(ReadySequence+0))*(C_num+1)+0))=sequence[i];
					*(ReadyTime+*(ReadySequence+0))=*(ReadyTime+*(ReadySequence+0))+CProTime[sequence[i]];
					*(C+sequence[i])=*(ReadyTime+*(ReadySequence+0));
				}
				else if(temp>=0.8 && temp<0.95)
				{
					*(m+(*(ReadySequence+1))*(C_num+1)+0)=*(m+(*(ReadySequence+1))*(C_num+1)+0)+1;
					*(m+(*(ReadySequence+1))*(C_num+1)+*(m+(*(ReadySequence+1))*(C_num+1)+0))=sequence[i];
					*(ReadyTime+*(ReadySequence+1))=*(ReadyTime+*(ReadySequence+1))+CProTime[sequence[i]];
					*(C+sequence[i])=*(ReadyTime+*(ReadySequence+1));
				}
				else
				{
					*(m+(*(ReadySequence+2))*(C_num+1)+0)=*(m+(*(ReadySequence+2))*(C_num+1)+0)+1;
					*(m+(*(ReadySequence+2))*(C_num+1)+*(m+(*(ReadySequence+2))*(C_num+1)+0))=sequence[i];
					*(ReadyTime+*(ReadySequence+2))=*(ReadyTime+*(ReadySequence+2))+CProTime[sequence[i]];
					*(C+sequence[i])=*(ReadyTime+*(ReadySequence+2));
				}
			}
		}
		else
		{
			for(i=M_num;i<C_num-1;i++)
			{
				for(j=0;j<M_num;j++)
					*(ReadySequence+j)=j;
				quick(ReadyTime,0,M_num-1,ReadySequence);
				temp=double(rand())/32857;
				if(temp<0.8)
				{
					*(m+(*(ReadySequence+0))*(C_num+1)+0)=*(m+(*(ReadySequence+0))*(C_num+1)+0)+1;
					*(m+(*(ReadySequence+0))*(C_num+1)+*(m+(*(ReadySequence+0))*(C_num+1)+0))=sequence[i];
					*(ReadyTime+*(ReadySequence+0))=*(ReadyTime+*(ReadySequence+0))+CProTime[sequence[i]];
					*(C+sequence[i])=*(ReadyTime+*(ReadySequence+0));
				}
				else
				{
					*(m+(*(ReadySequence+1))*(C_num+1)+0)=*(m+(*(ReadySequence+1))*(C_num+1)+0)+1;
					*(m+(*(ReadySequence+1))*(C_num+1)+*(m+(*(ReadySequence+1))*(C_num+1)+0))=sequence[i];
					*(ReadyTime+*(ReadySequence+1))=*(ReadyTime+*(ReadySequence+1))+CProTime[sequence[i]];
					*(C+sequence[i])=*(ReadyTime+*(ReadySequence+1));
				}
			}
		}
		for(j=0;j<M_num;j++)
			*(ReadySequence+j)=j;
		quick(ReadyTime,0,M_num-1,ReadySequence);
		*(m+(*(ReadySequence+0))*(C_num+1)+0)=*(m+(*(ReadySequence+0))*(C_num+1)+0)+1;
		*(m+(*(ReadySequence+0))*(C_num+1)+*(m+(*(ReadySequence+0))*(C_num+1)+0))=sequence[C_num-1];
		/*for(i=0;i<M_num;i++)
		{
			for(j=1;j<=*(m+i*(J_num+1)+0);j++)
				cout<<*(m+i*(J_num+1)+j)<<'	';
			cout<<endl;
		}*/
		*(C+sequence[i])=*(ReadyTime+*(ReadySequence+0))+CProTime[sequence[C_num-1]];
		objective=0;
		b=0;
		for(i=0;i<C_num;i++)
		{
			l=0;
			c=0;
			for(k=b+CNum[i]-1;k>=b;k--)
			{
				l=l+(*(Weight+k))*(*(C+i)-c);
				c=c+*(ProTime+k);
			}
			objective=objective+l;
			b=b+CNum[i];
		}
		i=0;
		while(*(BestObjective+i)<objective && i<10)
		{
			i++;
		}
		if(objective!=*(BestObjective+i))
		{
			for(j=9;j>i;j--)
			{
				*(BestObjective+j)=*(BestObjective+j-1);
				for(k=0;k<M_num;k++)
				{
					for(h=0;h<=*(BestM+(j-1)*(C_num+1)*M_num+k*(C_num+1)+0);h++)
						*(BestM+j*(C_num+1)*M_num+k*(C_num+1)+h)=*(BestM+(j-1)*(C_num+1)*M_num+k*(C_num+1)+h);
				}
			}
			*(BestObjective+i)=objective;
			for(k=0;k<M_num;k++)
			{
				for(h=0;h<=*(m+k*(C_num+1)+0);h++)
					*(BestM+i*(C_num+1)*M_num+k*(C_num+1)+h)=*(m+k*(C_num+1)+h);
			}
		}
	}
	/*for(k=0;k<10;k++)
	{
		for(i=0;i<M_num;i++)
		{
			for(j=1;j<=*(BestM+k*(J_num+1)*M_num+i*(J_num+1)+0);j++)
				cout<<*(BestM+k*(J_num+1)*M_num+i*(J_num+1)+j)<<'	';
			cout<<endl;
		}
		cout<<"the objective function value is:"<<*(BestObjective+k)<<endl;
	}*/
	
	
	
	

	rtn=0;
	int Low_cost=0;
	int sum_cost;
	if(rtn==0)
	{
		for(i=0;i<M_num;i++)
		{
			TempValue=0;
			K=0;
			H=0;
			path=new int [*(BestM+0*(C_num+1)*M_num+i*(C_num+1)+0)+1];
			for(j=1;j<*(BestM+0*(C_num+1)*M_num+i*(C_num+1)+0)+1;j++) 
			{
				path[j]=*(BestM+0*(C_num+1)*M_num+i*(C_num+1)+j)+1;
				H=K+*(CProTime+path[j]-1);
				b=0;
				for(k=0;k<path[j]-1;k++)
					b=b+CNum[k];
				l=0;
				c=0;
				for(k=b+CNum[path[j]-1]-1;k>=b;k--)
				{
					l=l+(*(Weight+k))*(H-c);
					c=c+*(ProTime+k);
				}
				TempValue=TempValue+l;
				K=H;
			}
			add_path(path,TempValue,*(BestM+0*(C_num+1)*M_num+i*(C_num+1)+0));
		}
		sum_cost=*(BestObjective+0);
		current_optimal=sum_cost;
		current_machine_num=M_num;
		for(i=0;i<current_machine_num;i++)
		{
			current_route[i][0]=*(BestM+0*(C_num+1)*M_num+i*(C_num+1)+0);
			for(j=1;j<current_route[i][0]+1;j++)
				current_route[i][j]=*(BestM+0*(C_num+1)*M_num+i*(C_num+1)+j)+1;
		}
		printf("the current_optimal become:%12lf\n",current_optimal);
		printf("the current_route become:\n");
		for(i=0;i<current_machine_num;i++)
		{
			for(j=1;j<current_route[i][0]+1;j++)
				printf("%d\t",current_route[i][j]);
			printf("\n");
		}
	}
	free(m);
	free(ReadyTime);
	free(ReadySequence);
	free(BestObjective);
	free(BestM);
	//temp_vehicle_num++;
	return(rtn);
}





/*********************************************************************/
/*[  Name  ] CacuDert                                                */
/*[Function] Caculate the reduce cost                                */
/*-------------------------------------------------------------------*/
/* [return] 1  have reduce cost                                      */
/*          0  node reduct cost                                      */
/*-------------------------------------------------------------------*/

int CacuDert(struct p *nodepath,double *dual_vars)

/*-------------------------------------------------------------------*/
{
	// 
    int     rtn;
    int     i;
	double     *TempCol;
	double  TempCost;
	double  Cacu;
	TempCol=new double[C_num+3];
	//for(i=1;i<=customer_num;i++)
	for(i=1;i<=C_num;i++)
		TempCol[i]=0;
	TempCol[0]=1;
	for(i=1;i<=nodepath->lenth;i++)
	{
		TempCol[nodepath->path[i]]++;
	}
	TempCost=nodepath->cost;
	Cacu=0;
	for(i=0;i<con_m-1;i++)
		Cacu+=((double)TempCol[i])*dual_vars[i];
	if(TempCost-Cacu<-(double)EPS2)
		rtn=1;
	else
		rtn=0;
	delete [] TempCol;
	return rtn;
}

void add_path(int *path,double cost,int len)
{
    struct p *newpath;
	newpath= new p;
    if (pathlist==NULL)
		newpath->No=1;
	else
		newpath->No=pathlist->No +1;
	newpath->cost=cost;
    newpath->lenth=len;
	newpath->path=path;
	//newpath->start=start;
	newpath->before=pathlist;
	pathlist=newpath;//add a path,here!
}

void add_path(struct p**nodepath)
{
	if(*nodepath)
	{
		if(pathlist==NULL)
 	        (*nodepath)->No=1;
	    else
	        (*nodepath)->No=pathlist->No +1;
		(*nodepath)->before=pathlist;
		pathlist=*nodepath;
	}
}
struct p* get_path( int No)
{    	
	struct p *now;
	now=pathlist;	
    while(1)
	{
		if(now->No==No)
		{
			return now;
		}
		else
		{
			if(now->before)
			   now=now->before;
			else
               return NULL;
		}
	}
}
void delete_path( int No)
{
	struct p *now;
	struct p *Del;
    int    *pp;
    now=pathlist;
	if(pathlist->No==No)
	{     
	   pathlist=pathlist->before;
	   pp=now->path;
	   free(now);
	   free(pp);
	}
	else
	{
		while (1)
		{
			if(now->No==No+1)
			{   
				Del=now->before;
				now->before=Del->before;
				pp=Del->path;
				free(Del);
				free(pp);
				break;
			}
			else
			{
				if(now->before)
					now=now->before;
				else
				{
					printf("don't Exist Such Path which No is %d ",No);
					break;
				}
			}
		}
	}
}

void clear_pathlist( )
{
	struct p *temp_path;
	int *pp;
	temp_path=pathlist;	
	while (temp_path)
	{
		pathlist=pathlist->before;
		pp=temp_path->path;
		delete [] pp;
		delete [] temp_path;
		temp_path=pathlist;
	}
}


void push_path(struct p**nodepath)
{
	if(*nodepath)
	{
		(*nodepath)->before=path_pool;
		path_pool=*nodepath;
	}
}

void pop_path(struct p**nodepath)
{
	*nodepath=path_pool;
	if(path_pool)
		path_pool=path_pool->before;
	if(*nodepath)
		(*nodepath)->before=NULL;
}

/*****************************************************************************/
/* [        ]                                                                */
/* [  Name  ]    void write_node( )                                          */
/* [Function]    Write the information of the branch node                    */
/*---------------------------------------------------------------------------*/


void write_node(struct n *node,int NumbInCol,int old_col_num,int NEW_COL_NUM)
/*---------------------------------------------------------------------------*/
/* <    >                                                                    */
/*****************************************************************************/
{
	int       i,j; 
    int       solu_numb;
	int       *Col;
	//char	  C1[2];
	float	gap;
	int sign;
	/*First Write curerent arc_matrix*/
	/*Write Column in Linear Model corresponding to path in pathlis*/
	Col=new int[NEW_COL_NUM-old_col_num+NumbInCol+1];
	for(i=1;i<=NumbInCol;i++)//look here
		Col[i]=ColInParent[i];
	for(i=NumbInCol+1;i<=NEW_COL_NUM-old_col_num+NumbInCol;i++)
		Col[i]=old_col_num+i-NumbInCol;
	node->Col=Col;
	/*Here We Will Get The Solution of Linear Model*/     
	const double *soln = ekk_colsol(Linear_Mode);    
    int          n=ekk_getInumcols(Linear_Mode);
    double       optimal=ekk_getRobjvalue(Linear_Mode ); 
	//process_time,ready_time,dead_line
	//strcpy(file_1,"pro_t");
	//strcat(file_1,".DAT");
	/*FILE *column;
	itoa(nodenum,a,10);
	char column_name[20]="column.txt";
	strcpy(column_name,"column");
	strcat(column_name,"-");
	strcat(column_name,a);
	strcat(column_name,".txt");
	column=fopen(column_name,"w");

	temppath=pathlist;
	fprintf(column,"___________________________________________________");
	while(1)
	{
		if(temppath==NULL)
			break;
		else
		{
 			fprintf(column,"%12lf\t%d\t%d\n",temppath->cost,temppath->weight,temppath->lenth);
			for(i=1;i<=temppath->lenth;i++)
				fprintf(column,"%d\t",temppath->path[i]);
			fprintf(column,"\n");
			temppath=temppath->before;
		}
	}
	fclose(column);*/
	/*We can test here wether var_n==n==NEW_COL_NUM - old_col_num +NumbInCol*/
	if(n!=var_n)
	{
		printf("Error because n!= var_n\n");
		getchar();
	}
	for(i=0;i<C_num;i++)
	{
		for(j=0;j<=*(B+i*(C_num+1)+0);j++)
		{
			node->NodeB[i][j]=*(B+i*(C_num+1)+j);
		}
	}
	solu_numb=0; 
	sign=1;
	for(i=0;i<n;i++)
	{
		if(Round(soln[i],6)>(double)EPS1)  //only record the number of current optimal solutions greater than ZERO
		//if(Round(soln[i],6)>=0)
		{
			solu_numb++;
			node->solution [solu_numb]=Round(soln[i],6);
			node->soluindex[solu_numb]=i+1;
			if(Round((soln[i]-floor(soln[i])),6)!=0)
			{
				sign=0;
			}
			/*now=get_path(i+1);
			printf("%12lf\t%d\t",now->cost,now->weight);
			for(j=1;j<now->lenth+1;j++)
			{
				printf("%d\t",*(now->path+j));
			}
			printf("\n");*/			
				
		}
	}
	node->lowerb=Round(optimal,0);
	node->column_num=n;
	node->solu_numb=solu_numb;
	if(node->lowerb>=current_optimal)//如果当前节点的下界比当前最优解还大，说明这个节点不可能得到最优解，删掉这个节点
		return;
	printf("the lower bound of node %d:is %12lf\n",nodenum,node->lowerb);
	printf("the current_optimal is:%12lf\n",current_optimal);
	if(nodenum==0)
		gap=(current_optimal-node->lowerb)/node->lowerb;
	else
		gap=(current_optimal-LBinBoot)/LBinBoot;
	printf("the dual gap is:%12lf\n",gap);
	if(solu_numb==M_num)
	//if(gap<=EPS1)
	{  // record the solution type 
		node->solu_type =0;
		node->r=0;
		node->s=0;
	}
	else
	{		
		node->solu_type=-1;
		GetBranchArc(node);
	}
/*	printf("old= %d ,new= %d couin=%d",old_col_num,NEW_COL_NUM,NumbInCol);
	for(i=1;i<=node->column_num;i++)
		printf("%d  ",node->Col[i]);
	getchar( );
*/
    if(solu_numb>N_MAX)    // deal with abnormality
	{
	    printf("\nerror occour during getcol!%d\n",solu_numb);
		exit(0);
	}
}

/**********************************************************************/
/*[  Name  ] GetBranchArc                                             */

/*[Function] Get The arc in the Network which be choosed to branch    */

/*--------------------------------------------------------------------*/

void GetBranchArc(struct n *node)

/*---------------------------------------------------------------------*/
{

	int      i,j;
	int      l;
	int      lenth;
	int      solution_number;
	double   Flow[N_MAX+1][N_MAX+1];
	double   MostFraArc;
	double   value;
	int      r,s;
//	int      Fixed,k;
    struct   p *NowPath;
	double		 temp[200];
	
	
	
	for(i=1;i<=N_MAX;i++)
		for(j=1;j<=N_MAX;j++)
			Flow[i][j]=0;
	solution_number=node->solu_numb;
	for(i=0;i<C_num;i++)
		temp[i]=0;
	for(l=1;l<=solution_number;l++)
	{
		NowPath=get_path(node->Col[node->soluindex[l]]);
		if(NowPath==NULL)
		{
			printf("Error When Getcol in GetBranchArc \n");
			getchar( );
			exit(0);
		}
        lenth=NowPath->lenth;
		for(i=1;i<lenth;i++)
		{
			temp[NowPath->path[i]-1]=temp[NowPath->path[i]-1]+node->solution[l];
			Flow[NowPath->path[i]][NowPath->path[i+1]]=Flow[NowPath->path[i]][NowPath->path[i+1]]+node->solution[l];
		}
	}
	r=0;
	s=0;
	MostFraArc=1;
	for(i=1;i<=C_num;i++)
	{
		for(j=i+1;j<=C_num;j++)
		{
			if(Flow[i][j]>0 && Flow[i][j]<1)
			{
				value=fabs(Flow[i][j]-0.5);
				if(MostFraArc>value)
				{
					MostFraArc=value;
					r=i;
					s=j;
				}
			}
		}
	}
	node->r=r;
	node->s=s;
	if(node->r==0 && node->s==0)
	{
		current_optimal=node->lowerb;
		current_machine_num=0;
		for(l=1;l<=solution_number;l++)
		{
			NowPath=get_path(node->Col[node->soluindex[l]]);
			if(NowPath==NULL)
			{
				printf("Error When Getcol in GetBranchArc \n");
				getchar( );
				exit(0);
			}
			current_route[l][0]=NowPath->lenth;
			for(j=1;j<=current_route[l][0];j++)
			{
				current_route[l][j]=NowPath->path[j];
				cout<<NowPath->path[j]<<'	';
			}
			cout<<endl;

		}
	}
	/*if((r!=0)&&(s!=0))
	{
		struct point_pair *temppoint;
		temppoint=new struct point_pair;
		temppoint->point_one=node->r;
		temppoint->point_two=node->s;
		temppoint->state=1;//生成左分支节点的约束标志
		if(point_pair)
		{
			temppoint->before=point_pair;
		}
		else
		{
			temppoint->before=NULL;
		}
		point_pair=temppoint;
	}*/
	printf("the point pair of node %d is:%d %d\n",nodenum,r,s);
	
}



//目前的问题是为什么nownode传不过来
//节点的压栈应该直接写到generatenode()中
/*****************************************************************************/
/* [  Name  ]    void backtracking()                                         */
/* [Function]    Back tracking in the branch tree                            */
/*---------------------------------------------------------------------------*/
void backtracking( )//没访问一个点后都要访问这个函数一次
/*---------------------------------------------------------------------------*/
/* <    >     //如果当前节点不可救药，那么。。。还没写呢                                                               */
/*****************************************************************************/
{
	int rtn;
	int nowlevel;
	struct n *nownode;
	
	struct n *first_node;  //The first node in the branch tree
	first_node=NULL;
    GenerateNode(first_node);
	
	while(1)
	{
		pop(&nownode);
		if(!nownode)
		   return;
		
		if(nownode->lowerb<result->lowerb) //if lowerb<Comp_min,there is the   
		{                                  //possibility to branch
			if((Round((result->lowerb - nownode->lowerb)/result->lowerb,4)<(double)Permit_Gap) &&(nownode->level>M_num)) 
			{
			    //but if the gap between best solution and this lowound at this node is 
			    //very minimal,we can cut this node
				free(nownode);
			}			
		    else
			{
				rtn=nownode->solu_type;   //judge the type of the current solution
			    if(rtn==0)    //the solution is integer, stop branching
				{             //save the current solution, backtracking
					delete [] result;
					result=nownode;
				}		
			    if(rtn==-1)  //the optimal solution is fractional, continue branching
				{	
					GenerateNode(nownode); //generate the next level nodes
                    free(nownode);
				}
			}
		}
		else if( nownode->lowerb==result->lowerb)
		{			
			rtn=nownode->solu_type;   //judge the type of the current solution
			if(rtn==0)    //the solution is integer, stop branching
			{           //save the current solution, backtracking
				delete [] result;
				result=nownode;
			}
			if(rtn==-1)  
                free(nownode);
		}
		else                       //if lowerb>Comp_min,prune the same level nodes
		{                          //continue backtracking
			nowlevel=nownode->level;
			do
			{
				free(nownode);
				pop(&nownode);
				if(nownode==NULL)
					return;
			}
			while(nownode->level==nowlevel);
			push(&nownode);
		}

		if (nodenum>=C_num)
		{         /*Here based the Max Branch Node to terminate the Algorithm*/   
            /*here maybe cause */
            pop(&nownode);
			while(nownode)
			{
				free(nownode);
				pop(&nownode);
			} 
			return;
		}
	}
	free(first_node);
	
}

/*****************************************************************************/
/* [      ]                                                                  */
/* [      ]    void push()                                                   */
/* [      ]                                                                  */
/*---------------------------------------------------------------------------*/
void push(struct n **node)
/*---------------------------------------------------------------------------*/
/* <    >                                                                    */
/*****************************************************************************/
{
	if(*node)
	{
		(*node)->next=nodelist;
		nodelist=*node;
	}
}

/*****************************************************************************/
/* [      ]                                                                  */
/* [      ]    void pop()                                                    */
/* [      ]                                                                  */
/*---------------------------------------------------------------------------*/
void pop(struct n **node)
/*---------------------------------------------------------------------------*/
/* <    >                                                                    */
/*****************************************************************************/
{
	*node=nodelist;
	if(nodelist)
		nodelist=nodelist->next;
	if(*node)
		(*node)->next=NULL;
}

/*****************************************************************************/
/* [      ]                                                                  */
/* [      ]    void sort()                                                   */
/* [      ]                                                                  */
/*---------------------------------------------------------------------------*/
void sort(struct n **list)
/*---------------------------------------------------------------------------*/
/* <    >                                                                    */
/*****************************************************************************/
{
	struct n *node1, *min, *before, *list0;
	before=NULL;
	list0=NULL;
	node1=*list;
	min=*list;
	while(*list)
	{
		while(node1)
		{
			if(node1->next)
			{
				if(node1->next->lowerb<min->lowerb)
				{
					min=node1->next;
					before=node1;
				}
				else if(node1->next->lowerb=min->lowerb)
				{
					if(node1->next->solu_type==0)
						min=node1->next;
					before=node1;
				}               
				/*Here add my idear sort by integer*/
			}
			node1=node1->next;
		}
		if(before==NULL)
		{
			*list=(*list)->next;
			min->next=list0;
			list0=min;
		}
		else
		{
			before->next=min->next;
			min->next=list0;
			list0=min;
		}
		before=NULL;
		node1=*list;
		min=*list;
	}
	*list=list0;
}

/*****************************************************************************/
/* [      ]    Generate node                                                   */
/* [      ]    void generate()                                                 */
/* [      ]                                                                     */
/*---------------------------------------------------------------------------*/
void GenerateNode(struct n *nownode)
/*---------------------------------------------------------------------------*/
/* <    >                                                                    */
/*****************************************************************************/
{
	int    rtn;
	struct n *nextnode, *tempnode, *tempsort;
	int    old_col_num;
	int    NumbInCol;
	int	   i,j,k,b;
	int r,s;
	nextnode=NULL;
	tempsort=NULL;
	tempnode=NULL;
	if(nownode==NULL)   // Generate The first node in the branch tree 
	{
	    GenFirstRmp( );
		linear_relax( );
		nextnode= new struct n;
        //generate the first node--the original problem
	    write_node(nextnode,0,0,NEW_COL_NUM);
		LBinBoot=nextnode->lowerb;               //Get the LowerBound at the Boot node
		nextnode->level=1;
		nextnode->next=NULL;
		tempsort=nextnode;
		rootcolu=rootcolu+var_n;
		colunum=colunum+var_n;
		maxcolu=maxcolu+var_n;
		while(tempsort)
		{
			tempnode=tempsort;
			tempsort=tempsort->next;
            tempnode->next=NULL;
			push(&tempnode);
		}
	    nodenum++;
		//Print_BranchNodeInf( nodenum,nextnode);
		return;
	}	
	if(nownode)   //generated the next level nodes of the current node
	{
		for(i=1;i<=2;i++)
		{
			r=nownode->r;
			s=nownode->s;
			NumbInCol=0;
            old_col_num=NEW_COL_NUM;
            ColInParent=new int[nownode->column_num];
			for(k=0;k<C_num;k++)
			{
				for(j=0;j<=nownode->NodeB[k][0];j++)
				{
					*(B+k*(C_num+1)+j)=nownode->NodeB[k][j];
				}
			}
			if(i==1)
			{
				for(j=0;j<C_num;j++)
				{
					if(sequence[j]==s-1)
					{
						k=j;
						break;
					}
				}
				*(B+k*(C_num+1)+0)=1;
				for(j=0;j<C_num;j++)
				{
					if(sequence[j]==r-1)
					{
						*(B+k*(C_num+1)+1)=j+1;
						break;
					}
				}
				for(j=0;j<C_num;j++)
				{
					if(sequence[j]!=s-1)
					{
						if(sequence[j]==r-1)
						{
							for(k=1;k<=*(B+j*(C_num+1)+0);k++)
							{
								if(sequence[*(B+j*(C_num+1)+k)-1]==r-1 || sequence[*(B+j*(C_num+1)+k)-1]==s-1)
								{
									for(b=k;b<*(B+j*(C_num+1)+0);b++)
										*(B+j*(C_num+1)+b)=*(B+j*(C_num+1)+b+1);
									*(B+j*(C_num+1)+0)=*(B+j*(C_num+1)+0)-1;
								}
							}
						}
						else
						{
							for(k=1;k<=*(B+j*(C_num+1)+0);k++)
							{
								if(sequence[*(B+j*(C_num+1)+k)-1]==r-1)
								{
									for(b=k;b<*(B+j*(C_num+1)+0);b++)
										*(B+j*(C_num+1)+b)=*(B+j*(C_num+1)+b+1);
									*(B+j*(C_num+1)+0)=*(B+j*(C_num+1)+0)-1;
								}
							}
						}
					}
				}
			}
			else
			{
				for(j=0;j<C_num;j++)
				{
					if(sequence[j]==s-1)
					{
						k=j;
						break;
					}
				}
				for(j=1;j<=*(B+k*(C_num+1)+0);j++)
				{
					if(sequence[*(B+k*(C_num+1)+j)-1]==r-1)
					{
						for(b=k;b<*(B+k*(C_num+1)+0);b++)
							*(B+k*(C_num+1)+b)=*(B+k*(C_num+1)+b+1);
						*(B+k*(C_num+1)+0)=*(B+k*(C_num+1)+0)-1;
					}
				}
			}
			rtn=GenNewRmp(i,nownode);   // update RMP's model;
            NumbInCol=var_n;
			if(rtn==0)
			{
				linear_relax();  
                nextnode=new n;
			    write_node(nextnode,NumbInCol,old_col_num,NEW_COL_NUM);
				colunum=colunum+var_n;
				if(maxcolu<var_n)
					maxcolu=var_n;
                nextnode->level=(nownode->level)+1;
				nextnode->tree=i;
		        nextnode->next=tempsort;
                tempsort=nextnode;
				// add new coumn to this node
			}
            else
			{
				printf("\n******************************************************\n");
				printf("\nError occur during call GenNewRmp,return incident error \n");
				exit(0);
			}
			delete [] ColInParent;
			nodenum++;
			//Print_BranchNodeInf( nodenum,nextnode);
		}
	    /* sort(&tempsort);
	    while(tempsort)
		{		
			tempnode=tempsort;
		    tempsort=tempsort->next;
		    tempnode->next=NULL;
		    push(&tempsort);
	     }*/
		if(tempsort->solu_type==-1 &&tempsort->next->solu_type==-1)
		{
			sort(&tempsort);
	        while(tempsort)
			{
				tempnode=tempsort;
				tempsort=tempsort->next;
				tempnode->next=NULL;
				push(&tempsort);
			}
			return;
		}
		if(tempsort->solu_type==-1 &&tempsort->next->solu_type==0)
		{
			while(tempsort)
			{
				tempnode=tempsort;
				tempsort=tempsort->next;
				tempnode->next=NULL;
				push(&tempsort);
			}	   
		    return;
		}
		if(tempsort->solu_type==0 &&tempsort->next->solu_type==-1)
		{
			tempnode=tempsort;
			tempsort=tempsort->next;
			tempsort->next=tempnode;
			tempnode->next=NULL;
		    while(tempsort)
			{
				tempnode=tempsort;
				tempsort=tempsort->next;
				tempnode->next=NULL;
				push(&tempsort);
			}
			return;
	   }
	   if(tempsort->solu_type==0 &&tempsort->next->solu_type==0)
	   {
		   sort(&tempsort);
	       while(tempsort)
		   {
			   tempnode=tempsort;
			   tempsort=tempsort->next;
			   tempnode->next=NULL;
			   push(&tempsort);
		   }
		   return;
	   }     
	} 
}

 
/*--------------------------------------------------------------------------------*/
/*                                                                                */
/*------------------------     End of Branch & Bound Algorthm          -----------*/
/*                                                                                */
/*--------------------------------------------------------------------------------*/



void print_path(struct p *nodepath) 
{
	int i;
	printf("Cost=%lf \n",nodepath->cost);
	for(i=1;i<=nodepath->lenth;i++)
		printf("%d ",nodepath->path[i]);
	printf("\n");
}
 






/*****************************************************************************/
/* [Prog]    pricing                                                         */
/* [Name]    void pricing()                                                  */
/* [return]     0   terminate                                                */
/*		       -1   still exist new column		                             */
/*             -999 Unexpect Error,maybe caused by backtracking    //where?          */
/*---------------------------------------------------------------------------*/
int DynamicPro(double dual, double *dual_vars)//每次最多找出10个最负费用列
/*---------------------------------------------------------------------------*/
/*                                                                           */
{
	int       i,j,k,a,b,c,sign,w;
	int       t;
	int       node_in_path;
	int       temp_path [MAXSLOT+1];             // a cycle path in the network
	int       *path;
	double    tempcost;
	int       colu_num,add_colu_num;
	struct p  *nodepath,*Criterion;
	int		  *descend;
	
	int *ROUTE,*LENGTH;
	double *RESULT;
	
	int signa;

	int l;
	int Total_p;
	int min_index;
	int x[200];
	double objective;	
	//int r[200];
	int result[200],result_length;
	double infinite;
	int temp;
	double *F;
	double h;
	struct BF *FF;
	
		
	descend = new int [1000000];
	
	w=0;
		
	ROUTE=(int *)malloc(sizeof(int)*C_num*10);
	LENGTH=(int *)malloc(sizeof(int)*10);
	RESULT=(double *)malloc(sizeof(double)*10);
	colu_num=0;
	
	infinite=100000;
		
	Total_p=0;
	for(i=0;i<C_num;i++)
		Total_p=Total_p+*(CProTime+i);
		
	if(nodenum==0)
	{
		
		F=(double *)malloc(sizeof(double)*(C_num+1)*(Total_p+1));
		b=0;
		for(i=0;i<=C_num;i++)
		{
			if(i==0)
			{
				for(j=0;j<=Total_p;j++)
					*(F+i*(Total_p+1)+j)=0;
			}
			else
			{
				for(j=0;j<=Total_p;j++)
				{
					if(j<*(CProTime+*(sequence+i-1)))
						*(F+i*(Total_p+1)+j)=*(F+(i-1)*(Total_p+1)+j);
						//*(F+i*(Total_p+1)+j)=infinite;
					else
					{
						h=0;
						c=0;
						for(k=b+CNum[*(sequence+i-1)]-1;k>=b;k--)
						{
							h=h+(*(Weight+k))*(j-c);
							c=c+*(ProTime+k);
						}
						if(*(F+(i-1)*(Total_p+1)+j-int(*(CProTime+*(sequence+i-1))))+h-dual_vars[*(sequence+i-1)+1]<*(F+(i-1)*(Total_p+1)+j))
							*(F+i*(Total_p+1)+j)=*(F+(i-1)*(Total_p+1)+j-int(*(CProTime+*(sequence+i-1))))+h-dual_vars[*(sequence+i-1)+1];
						else
							*(F+i*(Total_p+1)+j)=*(F+(i-1)*(Total_p+1)+j);
					}
				}
			}
			b=b+CNum[*(sequence+i-1)];
			/*for(j=0;j<=Total_p;j++)
				cout<<*(F+i*(Total_p+1)+j)<<'	';
			cout<<endl;*/
		}
		min_index=0;
		for(i=0;i<=Total_p;i++)
		{
			if(*(F+C_num*(Total_p+1)+min_index)>*(F+C_num*(Total_p+1)+i))
				min_index=i;
		}
		objective=*(F+C_num*(Total_p+1)+min_index);
		for(i=C_num;i>0;i--)
		{
			if(*(F+i*(Total_p+1)+min_index)==*(F+(i-1)*(Total_p+1)+min_index))
				x[i-1]=0;
			else
			{
				x[i-1]=1;
				min_index=min_index-int(*(CProTime+*(sequence+i-1)));
			}
		}
		result_length=0;
		for(i=0;i<C_num;i++)
		{
			if(x[i]==1)
			{
				result[result_length]=sequence[i];
				result_length++;
			}
		}
		/*r[0]=min_index;
		
		objective=0;
		for(i=0;i<result_length;i++)
		{
			C[i]=r[i]+p[result[i]];
			objective=objective+C[i]*w[result[i]];
			r[i+1]=C[i];
		}*/
		if(objective-dual>=-EPS2)
		{
			delete [ ] descend;
			free(LENGTH);
			free(ROUTE);
			free(F);
			free(RESULT);
			return(0);
		}
		else
		{
			*(RESULT+0)=objective;
			*(LENGTH+0)=result_length;
			for(i=0;i<result_length;i++)
			{
				*(ROUTE+i)=result[i]+1;
			}
			colu_num=1;
			/*for(i=0;i<=Total_p;i++)
			{
				if(*(F+J_num*(Total_p+1)+i)-dual<-EPS2 && i!=min_index)
				{
					temp=i;
					for(j=J_num;j>0;j--)
					{
						if(*(F+j*(Total_p+1)+temp)==*(F+(j-1)*(Total_p+1)+temp))
							x[j-1]=0;
						else
						{
							x[j-1]=1;
							temp=temp-*(ProTime+*(sequence+j-1));
						}
					}
					*(LENGTH+colu_num)=0;
					*(RESULT+colu_num)=*(F+J_num*(Total_p+1)+i);//应该把对偶变量都抛掉		
					for(j=0;j<J_num;j++)
					{
						if(x[j]==1)
						{
							*(ROUTE+colu_num*J_num+*(LENGTH+colu_num))=sequence[j]+1;
							(*(LENGTH+colu_num))++;
						}
					}
					colu_num++;
				}
				if(colu_num==9)
					break;
			}*/
		}
	}
	else
	{
		
		FF=(struct BF *)malloc(sizeof(struct BF)*(C_num+1)*(Total_p+1));
		int min_index_j,min_index_t;
		int temp_j,temp_t;
		b=0;
		for(i=0;i<=C_num;i++)
		{
			if(i==0)
			{
				for(j=0;j<=Total_p;j++)
				{
					(*(FF+i*(Total_p+1)+j)).FValue=0;
					(*(FF+i*(Total_p+1)+j)).index_j=0;
					(*(FF+i*(Total_p+1)+j)).before=NULL;
				}
			}
			else
			{
				for(j=0;j<=Total_p;j++)
				{
					if(j<int(*(CProTime+*(sequence+i-1))))
					{
						(*(FF+i*(Total_p+1)+j)).FValue=infinite;
						(*(FF+i*(Total_p+1)+j)).index_j=0;
						(*(FF+i*(Total_p+1)+j)).before=FF+0*(Total_p+1)+j;
					}
					else
					{
						h=0;
						c=0;
						for(l=b+CNum[*(sequence+i-1)]-1;l>=b;l--)
						{
							h=h+(*(Weight+l))*(j-c);
							c=c+*(ProTime+l);
						}
						(*(FF+i*(Total_p+1)+j)).FValue=(*(FF+(*(B+(i-1)*(C_num+1)+1))*(Total_p+1)+j-int(*(CProTime+*(sequence+i-1))))).FValue+h-dual_vars[*(sequence+i-1)+1];
						(*(FF+i*(Total_p+1)+j)).index_j=*(B+(i-1)*(C_num+1)+1);
						(*(FF+i*(Total_p+1)+j)).before=FF+(*(B+(i-1)*(C_num+1)+1))*(Total_p+1)+j-int(*(CProTime+*(sequence+i-1)));
						for(k=2;k<*(B+(i-1)*(C_num+1)+0)+1;k++)
						{							
							if((*(FF+(*(B+(i-1)*(C_num+1)+k))*(Total_p+1)+j-int(*(CProTime+*(sequence+i-1))))).FValue+h-dual_vars[*(sequence+i-1)+1]<(*(FF+i*(Total_p+1)+j)).FValue)
							{
								(*(FF+i*(Total_p+1)+j)).FValue=(*(FF+(*(B+(i-1)*(C_num+1)+k))*(Total_p+1)+j-int(*(CProTime+*(sequence+i-1))))).FValue+h-dual_vars[*(sequence+i-1)+1];
								(*(FF+i*(Total_p+1)+j)).index_j=*(B+(i-1)*(C_num+1)+k);
								(*(FF+i*(Total_p+1)+j)).before=FF+(*(B+(i-1)*(C_num+1)+k))*(Total_p+1)+j-int(*(CProTime+*(sequence+i-1)));
							}
						}
					}
				}
			}
			b=b+CNum[*(sequence+i-1)];
			/*for(j=0;j<=Total_p;j++)
				cout<<*(F+i*(Total_p+1)+j)<<'	';
			cout<<endl;*/
		}
		min_index_j=1;
		min_index_t=0;
		for(i=0;i<=C_num;i++)
		{
			for(j=0;j<=Total_p;j++)
			{
				if((*(FF+min_index_j*(Total_p+1)+min_index_t)).FValue>(*(FF+i*(Total_p+1)+j)).FValue)
				{
					min_index_j=i;
					min_index_t=j;
				}
			}
		}
		objective=(*(FF+min_index_j*(Total_p+1)+min_index_t)).FValue;
		while((*(FF+min_index_j*(Total_p+1)+min_index_t)).before!=NULL && min_index_t>=0)
		{
			//if((*(FF+min_index_j*(Total_p+1)+min_index_t)).FValue==(*(FF+((*(FF+min_index_j*(Total_p+1)+min_index_t)).index_j)*(Total_p+1)+min_index_t)).FValue)
			//{
			//	x[min_index_j-1]=0;
			//	min_index_j=(*(FF+min_index_j*(Total_p+1)+min_index_t)).index_j;
			//}
			//else
			//{
				x[min_index_j-1]=1;
				temp=min_index_j;
				min_index_j=(*(FF+min_index_j*(Total_p+1)+min_index_t)).index_j;
				min_index_t=min_index_t-*(CProTime+*(sequence+temp-1));		
			//}
		}
		/*i=min_index_j;
		temp=*(F+min_index_j*(Total_p+1)+min_index_t);
		while(min_index_j!=0)
		{
			if(*(F+0*(Total_p+1)+min_index_t-*(ProTime+*(sequence+i-1)))+(*(Weight+*(sequence+i-1)))*min_index_t+dual_vars[*(sequence+i-1)+1]==*(F+i*(Total_p+1)+min_index_t))
			{
				x[i-1]=1;
				min_index_j=0;
				min_index_t=min_index_t-*(ProTime+*(sequence+i-1));
			}
			else if(*(F+0*(Total_p+1)+min_index_t)!=*(F+i*(Total_p+1)+min_index_t))
			{
				x[i-1]=0;
				min_index_j=0;
			}
			else
			{
				for(j=1;j<*(B+i*(J_num+1)+0)+1;j++)
				{
					if(*(F+j*(Total_p+1)+min_index_t-*(ProTime+*(sequence+i-1)))+(*(Weight+*(sequence+i-1)))*min_index_t+dual_vars[*(sequence+i-1)+1]==*(F+i*(Total_p+1)+min_index_t))
					{
						x[i-1]=1;
						min_index_t=min_index_t-*(ProTime+*(sequence+i-1));
						min_index_j=j;
						break;
					}
				}
			}
		}*/
		result_length=0;
		for(i=0;i<C_num;i++)
		{
			if(x[i]==1)
			{
				result[result_length]=sequence[i];
				result_length++;
			}
		}
		//r[0]=min_index_t;
		
		/*objective=0;
		for(i=0;i<result_length;i++)
		{
			C[i]=r[i]+p[result[i]];
			objective=objective+C[i]*w[result[i]];
			r[i+1]=C[i];
		}*/
		if(objective-dual>=-EPS2)
		{
			delete [ ] descend;
			free(ROUTE);
			free(LENGTH);
			free(RESULT);
			free(FF);
			return(0);
		}
		else
		{
			*(RESULT+0)=objective;
			*(LENGTH+0)=result_length;
			for(i=0;i<result_length;i++)
			{
				*(ROUTE+i)=result[i]+1;
			}
			colu_num=1;
			/*for(i=1;i<=J_num;i++)
			{
				for(k=*(ProTime+sequence[i-1]);k<=Total_p;k++)
				{
					if(((*(FF+i*(Total_p+1)+k)).FValue-dual<-EPS2 && i!=min_index_j)||((*(FF+i*(Total_p+1)+k)).FValue-dual<-EPS2 && k!=min_index_t))
					{
						temp_j=i;
						temp_t=k;
						for(j=0;j<J_num;j++)
							x[j]=0;
						*(RESULT+colu_num)=(*(FF+i*(Total_p+1)+k)).FValue;//应该把对偶变量都抛掉
						while((*(FF+temp_j*(Total_p+1)+temp_t)).before!=NULL)
						{
							if((*(FF+temp_j*(Total_p+1)+temp_t)).FValue==(*(FF+((*(FF+temp_j*(Total_p+1)+temp_t)).index_j)*(Total_p+1)+temp_t)).FValue)
							{
								x[temp_j-1]=0;
								temp_j=(*(FF+temp_j*(Total_p+1)+temp_t)).index_j;
							}
							else
							{
								x[temp_j-1]=1;
								temp_t=temp_t-*(ProTime+*(sequence+temp_j-1));
								temp_j=(*(FF+temp_j*(Total_p+1)+temp_t)).index_j;
							}
						}
						*(LENGTH+colu_num)=0;		
						for(j=0;j<J_num;j++)
						{
							if(x[j]==1)
							{
								*(ROUTE+colu_num*J_num+*(LENGTH+colu_num))=sequence[j]+1;
								//cout<<*(ROUTE+colu_num*J_num+*(LENGTH+colu_num))<<'	';
								(*(LENGTH+colu_num))++;
							}
						}
						//cout<<endl;
						colu_num++;
					}
					if(colu_num==9)
						break;
				}
				if(colu_num==9)
					break;
			}*/
		}
	}
	/*if(objective!=*(F+J_num*(Total_p+1)+min_index))
		cout<<"there may be some error!"<<endl;
	for(i=0;i<result_length;i++)
		cout<<result[i]<<'	';
	cout<<endl;
	cout<<objective<<endl;*/
	
	
	
	
	add_colu_num=0;
	for(i=0;i<colu_num;i++)
	{
		/*sign=1;
		Criterion=pathlist;
		while(1)
		{
			if(Criterion==NULL)
				break;
			if(Criterion->lenth==*(LENGTH+i))
			{
				k=0;
				for(a=1;a<=*(LENGTH+i);a++)
				{
					signa=0;
					for(j=1;j<=Criterion->lenth;j++)
					{
						if(*(ROUTE+i*J_num+a-1)==Criterion->path[j])
						{
							k++;
							signa=1;
							break;
						}
					}
					if(signa==0)
						break;
				}
				if(signa==1)
				{
					sign=0;
					break;
				}
			}
			Criterion=Criterion->before;
		}
		if(sign==1)
		{*/
			descend[add_colu_num]=i;
			add_colu_num++;
		//}	
	}
	if(add_colu_num==0)
	{
		delete [ ] descend;
		free(ROUTE);
		free(LENGTH);
		free(RESULT);
		if(nodenum==0)
			free(F);
		else
			free(FF);
		return(0);
	}
	for(i=0;i<add_colu_num-1;i++) /*外循环：控制比较趟数*/
	{
		for(j=add_colu_num-1;j>i;j--) /*内循环：进行每趟比较*/
		{
			if(*(RESULT+descend[j])<*(RESULT+descend[j-1])) /*如果data[j]大于data[j-1],交换两者的位置*/
			{
				k=descend[j];
				descend[j]=descend[j-1];
				descend[j-1]=k;
			}
		}
    }
	for(i=0;i<add_colu_num;i++)
	{
		node_in_path=*(LENGTH+descend[i]);
		temp_path[0]=node_in_path;
		tempcost=*(RESULT+descend[i]);
		nodepath =new p;
		path     =new int[node_in_path+1];
		//start    =new float[node_in_path+1];
		t=0;
		for(j=1;j<=node_in_path;j++)
		{
			path[j]=*(ROUTE+descend[i]*C_num+j-1);
			//cout<<path[j]<<'	';
			tempcost=tempcost+dual_vars[path[j]];
		}
		//cout<<tempcost<<endl;
		nodepath->cost=tempcost;
		nodepath->lenth=node_in_path;
		nodepath->path=path;
		push_path(&nodepath);
	}
	delete [ ] descend;
	if(nodenum==0)
		free(F);
	else
		free(FF);
	free(ROUTE);
	free(LENGTH);
	free(RESULT);
	return(-1);		   	 
}
















/***************************************************************************/
/*[  Name  ] Round                                                         */
/*[Function] get approxmate number of x,the precision is at positon len    */
/*-------------------------------------------------------------------------*/

double Round(double x,int len)

/*-------------------------------------------------------------------------*/
{
	double result;
	double eps;
	double temp;
	double reduce;
	eps=1/(pow(10,len));
	result=x/eps;
	if(result>=0)
	{ 
		temp=floor(result);
		reduce=result-temp;
		if(reduce<=0.5)
			temp=temp;
		else
			temp=temp+1;
	}
	else
	{
		temp=ceil(result);
		reduce=temp-result;
		if(reduce<=0.5)
			temp=temp;	   
		else
			temp=temp-1;
	}
	result=temp*eps;
	return result;
}














